//+------------------------------------------------------------------+
//|RK-HMA_Expert_v3wKC & RK_HMA_v2&RK-KeltnerChannels-atr-ml-Alert   |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|Copyright 2007,TrendLaboratory Ltd.E-mail:igorad2003@yahoo.co.uk |
//| 1.Converted ECN & 5 digit 2-21-10, added KC& RSI 03-22-2012 RK   |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"
#include <stdlib.mqh>
//---- input parameters
extern string     Expert_Name    =    "RK-Wpr-wBands_Expert_v1-nf";
extern string     Indicator_Name =    "RK-wpr-wbands-nf";
extern int        Magic          = 0;    // if Magic=0 then AutoMagic
extern int        Slippage       = 7;
extern string     Main_data      =    " Trade Volume & Trade Method";
extern double     Lots           = 0.1;    // Trade Volume 
extern int        MaxOrders      = 1;
extern double     TakeProfit     = 0;    // Take Profit Value in pips 
extern double     StopLoss       = 0;    // Initial Stop Value in pips
extern int        TrailingMode   = 1;    // 0-off,1-standard,2-System by HMA  
extern double     TrailingStop   = 20;    // Trailing Stop Value in pips
extern double     StopDeviation  = 0;    // Deviation of Hi/Lo HMA
extern double     BreakEven      = 13;    // Break-Even Value in pips
extern double     ProfitLock     = 6;    // Profit Lock in pips
extern bool       SignalMail     = False;    // E-mail Alert Switch

extern int        TimeFrame       = 0;
extern int        WprPeriod       = 14;
extern int        BandsPeriod     = 14;
extern double     BandsDeviations = 0.5;  
extern int        Shift           = 1;    // Shift relative to the current bar

extern string     Time_Inputs    =     " Timing parameters ";
extern int        StartHour      = 0;    // Start Hour of Trade Session 
extern int        StartMinute    = 0;    // Start Minute of Trade Session 
extern int        EndHour        = 24;    // End Hour of Trade Session
extern int        EndMinute      = 0;    // End Hour of Trade Session
extern int        CloseTimeMode  = 0;    // CloseTime mode: 0-off,1-on
extern int        CloseHour      = 24;    // Trade Close Hour   
extern int        CloseMinute    = 0;    // Trade Close Minute   

extern string     HMA_Inputs     =    " HMA_v3.2 parameters";
//extern int        TimeFrame      = 0;    // Time Frame in min
extern int        Price          = 6;  //0-C;1-O,2-H,3-L,4-Mdn Pr,5-Typl Pr,6-Wghtd Close"
extern int        HMA_Period     = 3;
extern int        HMA_Mode       = 3;  //0 => SMA; 1 => EMA; 2 => SMMA; 3 => LWMA - Added by Chrisstoff
extern double     PctFilter      = 1.0;    // Dynamic filter in decimal
//extern int        Shift          = 0;    // Shift relative to the current bar

extern string     KC_Inputs      =    " RK-KC-wtrend_arrows";
extern int        KCperiod       = 4;    //Keltner Channel Length
extern double     KCatr          = 0.5;    //Keltner Channel Width

extern string     RSI_Inputs      =    " RSI-inputs";
extern int        timeFrame      = 0;
extern int        RSIperiod      = 2;
extern int        applied_price  = 0;
extern int        shiftrsi       = 0;
extern int        rsilvl         = 50;

extern string     Entry_Mode1_3     =  "0=Off, 1=Signal/trd, 2= Trd Revl, 3=HMA-trd & KC ";
extern string     Entry_Mode4_5     =  "0=Off, 4=HMA-trd & RSI, 5=HMA-trd & KC & RSI";
extern int        Mode           = 1;   
extern string     Exit_Mode      =  "0=TP&SL Only,1=HMASig-X, 2=HMATrdRevl-X, 3=HMA OR KC X";
extern int        ExitMode       = 1;  

extern string     MM_inputs      =    " MoneyManagement by L.Williams ";
extern bool       MM             = false;    //  Switch
extern double     MaxRisk        = 1.00;    // Risk Factor

datetime          timeprev       = 0;       // Only run once per completed bar

int      OrderBar=0;
double   Lotsi;
int      BEvent=0, TriesNum=5;
datetime CurrBar,PrevBar;
double   UpLine, DnLine;
double   wpr, wpr1, bbup, bbmid, bblwr, trend, ptrend;
double pointvalue;
int      aMagic;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
 
    
 //Convert to 3 & 5 diget broker
    if (Digits == 4 || Digits == 2) pointvalue = Point;
      else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
 //---- 
   if(Magic==0)
   aMagic=3000+func_Symbol2Val(Symbol())*100 + func_TimeFrame_Const2Val(Period()); 
   else
   aMagic = Magic;
    
   CurrBar = iTime(Symbol(),0,0);
   PrevBar = iTime(Symbol(),0,1);
 //----
   return(0);
}
// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == aMagic) 
   numords++;
   }
   return(numords);
}  

bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;
   else
   if (StartHour > EndHour)
   result = (TimeCurrent() > SessionStart && TimeHour(TimeCurrent()) < 24)||
                              (TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   return(result);
}   

int HMA_Trend(int mode)
{   
   int result = 0; 
                       //   Indicator_Name =    "RK-wpr-wbands-nf";  Shift = 1
  wpr =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,0,Shift);
  wpr1 =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,0,Shift+1);
  bbup =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,1,Shift);
  bbmid =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,2,Shift);
  bblwr =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,3,Shift);
  
  
  
  ptrend=iCustom(NULL,0,"RK-wpr-wbands-nf",0,Price,HMA_Period,HMA_Mode,PctFilter,4,Shift+1);
  
  double upper =iCustom(NULL, 0,"RK-KC-wtrend_arrows",KCperiod,KCatr,0,0);
  double middle=iCustom(NULL, 0,"RK-KC-wtrend_arrows",KCperiod,KCatr,1,0);
  double lower =iCustom(NULL, 0,"RK-KC-wtrend_arrows",KCperiod,KCatr,2,0);
  
  double rsi  = iRSI (NULL,timeFrame ,RSIperiod,0,shiftrsi+0);
      
   if (Mode == 1) //trend/signal
   {      
      if (wpr > bbup && wpr > wpr1) result =  mode;
      if (wpr < bblwr && wpr < wpr1) result = -mode; 
     // if (trend > 0 && ptrend > 0) result =  mode;  
     // if (trend < 0 && ptrend < 0) result = -mode; 
     // if (trend > 0 && ptrend > 0 && rsi > rsilvl ) result =  mode;  
     // if (trend < 0 && ptrend < 0 && rsi < rsilvl ) result = -mode; 
   }
  /* else
   if (Mode == 2) //trend reversal
   {      
      if (trend > 0 && ptrend < 0) result =  mode;  
      if (trend < 0 && ptrend > 0) result = -mode;
   }
   else
   if (Mode ==3) //trend/signal & KC
   {   
      //if (trend > 0 && Open[1] < upper && Close[1] > upper && Close[0] > upper) result =  mode;
      //if (trend < 0 && Open[1] > lower && Close[1] < lower && Close[0] < lower) result = -mode;
      if (trend > 0 &&  Close[1] > upper && Close[0] > upper) result =  mode;
      if (trend < 0 && Close[1] < lower && Close[0] < lower) result = -mode;  
   }
   else
   if (Mode ==4) //trend/signal & RSI
   {   
      if (trend > 0 && rsi > rsilvl ) result =  mode;
      if (trend < 0 && rsi < rsilvl ) result = -mode;
   }
   else
   if (Mode ==5) //trend/signal & RSI
   {   
      if (trend > 0 && rsi > rsilvl ) result =  mode;
      if (trend < 0 && rsi < rsilvl ) result = -mode;
   }
   else
   if (Mode ==6) //trend/signal & RSI & KC
   {   
      if (trend > 0 && Close[1] > upper && Close[0] > upper && rsi > rsilvl) result =  mode;
      if (trend < 0 && Close[1] < lower && Close[0] < lower && rsi < rsilvl) result = -mode;
   }
  
  */
  
  
   
   
   if(mode == 0) result = 0;
   
   return(result); 
}
int TradeSignal()
{   
   int Signal =0;
   if (Mode>0 || ExitMode == 1) int hma  = HMA_Trend(Mode); else hma=0; 
   if (TimeCondition())
   {
   if ( hma == Mode) Signal = 1;
   if ( hma ==-Mode) Signal =-1;
   }  
   return(Signal);
}

double MoneyManagement()
{
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract=MarketInfo(Symbol(),MODE_LOTSIZE);
   double vol;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
//--- basic formula
   if ( MM )
   vol=NormalizeDouble(AccountFreeMargin()*MaxRisk*AccountLeverage()/contract,2);
   else
   vol=Lots;
//--- check min, max and step
   vol=NormalizeDouble(vol/lot_step,0)*lot_step;
   if(vol<lot_min) vol=lot_min;
   if(vol>lot_max) vol=lot_max;
//---
   return(vol);
}   


void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==aMagic) 
      {
// - Buy Orders
         if (mode==OP_BUY) 
         {
			   if ( BreakEven > 0 && BEvent==0 )
			   {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/pointvalue;
			      if( Gain >= BreakEven && OrderStopLoss()<=OrderOpenPrice()+ProfitLock*pointvalue) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice()+ProfitLock*pointvalue,Digits);
			      BEvent=1;
			      }
			   }
			   else 			   
			   if(TrailingMode==1&&TrailingStop>0)BuyStop=NormalizeDouble(MarketInfo(Symbol()
			                                         ,MODE_BID) - TrailingStop*pointvalue,Digits);
			   else
			   if(TrailingMode==2&&UpLine>0)BuyStop=NormalizeDouble((1.0-0.01*StopDeviation)*UpLine,Digits);
			   
			   if( NormalizeDouble(OrderOpenPrice(),Digits)<= BuyStop) 
            {   
			      if(BuyStop>NormalizeDouble(OrderStopLoss(),Digits)||OrderStopLoss()==0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              BuyStop,
			                              OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
            if ( BreakEven > 0 && BEvent==0)
			   {
			   Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/pointvalue;
			   
			   if( Gain >= BreakEven && (OrderStopLoss()>=OrderOpenPrice()-ProfitLock*pointvalue ||
			                                                                   OrderStopLoss()== 0)) 
			      {
			      double SellStop = NormalizeDouble(OrderOpenPrice()-ProfitLock*pointvalue, Digits);
			      BEvent=-1;
			      }
			   }
			   else 
			   if (TrailingStop > 0 && TrailingStop > 0) SellStop = NormalizeDouble
			         (MarketInfo(Symbol(),MODE_ASK) + TrailingStop*pointvalue,Digits);   
            else
            if( TrailingMode==2 && DnLine>0) SellStop = NormalizeDouble
                                          ((1.0+0.01*StopDeviation)*DnLine,Digits);
                        
            if(NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop>0) 
            {
           if(SellStop<NormalizeDouble(OrderStopLoss(),Digits)||OrderStopLoss()==0) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              SellStop,
			                              OrderTakeProfit(),0,Orange);
                  Print("Sellstop  -",SellStop);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   			}	    
         }
      }
   }     
}
// End Of Trailing void

// ---- Open Sell Orders
void SellOrdOpen()
{		     
   double SellPrice = Bid;
   double StopPrice = Bid;
   int    Mode = OP_SELL;
        	  
   if (StopLoss > 0) double SellStop  = StopPrice + StopLoss*pointvalue; 
	else 
	if(TrailingMode==2&&DnLine>0) SellStop=NormalizeDouble((1.0+0.01*StopDeviation)*DnLine,Digits); 
	else SellStop = 0;
   
   if (TakeProfit  > 0) double SellProfit = SellPrice-TakeProfit*pointvalue; 
   else SellProfit=0;
   
	int ticket = OrderSend( Symbol(),Mode,MoneyManagement(),
	                        NormalizeDouble(SellPrice , Digits),
	                        Slippage,
	                        0,//NormalizeDouble(SellStop  , Digits),
	                        0,//NormalizeDouble(SellProfit, Digits),
	                        Expert_Name+" SELL",aMagic,0,Red);
   
   if(ticket > 0) 
   {
      if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
		OrderModify(ticket,OrderOpenPrice(),SellStop, SellProfit,0,DarkRed);
		//OrderBar =iBars(OrderSymbol(),BT_TimeFrame);
		Print("SELL order opened : "," #  ",ticket,"  ", OrderOpenPrice());
      BEvent=0;
      if (SignalMail)SendMail("[Signal Alert]", "[" + Symbol() + "] " +DoubleToStr(Bid, Digits)
                                                                               + " Open Sell");
		}
   }
	else 	
   if(GetLastError()>0)
   Print("SELL: OrderSend failed with error #",GetLastError());
   
   //return(0);
}
// ---- Open Buy Orders
void BuyOrdOpen()
{		     
   double BuyPrice  = Ask;
   double StopPrice = Ask;
   int    Mode      = OP_BUY;
      
   if (StopLoss > 0) double BuyStop  = StopPrice - StopLoss*pointvalue; 
	else 
	if (TrailingMode==2&&UpLine> 0) BuyStop=NormalizeDouble((1.0-0.01*StopDeviation)*UpLine,Digits); 
	else BuyStop = 0;
   
   if (TakeProfit>0)double BuyProfit= BuyPrice + TakeProfit*pointvalue;
   else BuyProfit=0;  
		 
	int ticket = OrderSend(Symbol(),Mode, MoneyManagement(),
	                   NormalizeDouble(BuyPrice , Digits),
	                   Slippage,
	                   0,//NormalizeDouble(BuyStop  , Digits), 
	                   0,//NormalizeDouble(BuyProfit, Digits),
	                   Expert_Name+" BUY",aMagic,0,Blue);
      
   if(ticket > 0) 
   {
      if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
		OrderModify(ticket,OrderOpenPrice(),BuyStop, BuyProfit,0,DarkRed);
		//OrderBar =iBars(OrderSymbol(),BT_TimeFrame); 
		Print("BUY order opened : "," # ",ticket,"   ", OrderOpenPrice());
      BEvent=0;
      if (SignalMail)SendMail("[Signal Alert]", "[" + Symbol() + "] " +DoubleToStr(Ask, Digits) + " Open Buy");
		}
   }
	else 	
   if(GetLastError()>0)      
   Print("BUY : OrderSend failed with error #",GetLastError());

   //return(0);
} 

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=0; i<=OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == aMagic && OrderSymbol() == Symbol()) 
      {
      if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) result=CloseAtMarket(OrderTicket(),OrderLots(),Aqua);
      if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) result=CloseAtMarket(OrderTicket(),OrderLots(),Pink);
      }
   }
}


bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   //int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      //ntr=0; 
      //while (ntr<5 && !IsTradeAllowed()) { ntr++; Sleep(5000); }
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   // Only run once per completed bar
    // if(timeprev==Time[0]) return(0);
    // timeprev = Time[0];
   
   if (TimeFrame==0) TimeFrame = Period();
       
   if(iBars(Symbol(),TimeFrame) < 100 || IsTradeAllowed()==false) return(0); 
      
   if(AccountFreeMargin()< 1000*MoneyManagement ())
   {
   Print("We have no money. Free Margin = ", AccountFreeMargin());
   return(0);  
   }
   CurrBar = iTime(Symbol(),0,0);
   
   datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
   
   
      
   if (CurrBar != PrevBar)
   {
      double upper =iCustom(NULL, 0,"RK-KC-wtrend_arrows",KCperiod,KCatr,0,0);
      double middle=iCustom(NULL, 0,"RK-KC-wtrend_arrows",KCperiod,KCatr,1,0);
      double lower =iCustom(NULL, 0,"RK-KC-wtrend_arrows",KCperiod,KCatr,2,0);
      
      wpr =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,0,Shift);
      wpr1 =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,0,Shift+1);
      bbup =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,1,Shift);
      bbmid =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,2,Shift);
      bblwr =iCustom(NULL,0,"RK-wpr-wbands-nf","calculateValue",WprPeriod,BandsPeriod,BandsDeviations,3,Shift);
      
      if(TrailingMode==2)
      {
     UpLine  = iCustom(NULL,TimeFrame,"RK-HMA_v3.2",2,HMA_Period,HMA_Mode,PctFilter,0,Shift);
     DnLine  = iCustom(NULL,TimeFrame,"RK-HMA_v3.2",3,HMA_Period,HMA_Mode,PctFilter,0,Shift);
      }
      
      int Signal = TradeSignal();
      //Print(" Sig=",Signal);      
      if(ScanTrades()>0)
      {
       if(ExitMode == 1)
        {
         if (Signal > 0 ) CloseOrder(2);
         if (Signal < 0 ) CloseOrder(1);
        }
      /* else
       if(ExitMode == 2)
        {
         if (trend > 0 && ptrend < 0) CloseOrder(2);
         if (trend < 0 && ptrend > 0) CloseOrder(1);
        }
       else
       if(ExitMode == 3)
        {
         if ((Signal > 0) || (Close [1] > lower && Close [0] > middle)) CloseOrder(2);
         if ((Signal < 0) || (Close [1] < upper && Close [0] < middle)) CloseOrder(1);
       // if (Signal > 0 || Close [1] > lower ) CloseOrder(2);
        // if (Signal < 0 || Close [1] < upper ) CloseOrder(1);
        
        }*/
      if (CloseTimeMode > 0 && TimeCurrent() >= TimeClose) CloseOrder(0); 
      }
      
      if(ScanTrades() < MaxOrders)
      {
      if (Signal > 0) BuyOrdOpen() ;
      if (Signal < 0) SellOrdOpen();
      }
   }
   else
   if(ScanTrades()>0)
   {
   if(BreakEven > 0 || TrailingMode>0) TrailStop();
   }
   PrevBar = CurrBar;
 
//----
   return(0);
} //start()
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Time frame interval appropriation  function                      |
//+------------------------------------------------------------------+

int func_TimeFrame_Const2Val(int Constant ) {
   switch(Constant) {
      case 1:  // M1
         return(1);
      case 5:  // M5
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}



int func_Symbol2Val(string symbol)
 {
   string mySymbol = StringSubstr(symbol,0,6);
	if(mySymbol=="AUDCAD") return(1);
	if(mySymbol=="AUDJPY") return(2);
	if(mySymbol=="AUDNZD") return(3);
	if(mySymbol=="AUDUSD") return(4);
	if(mySymbol=="CHFJPY") return(5);
	if(mySymbol=="EURAUD") return(6);
	if(mySymbol=="EURCAD") return(7);
	if(mySymbol=="EURCHF") return(8);
	if(mySymbol=="EURGBP") return(9);
	if(mySymbol=="EURJPY") return(10);
	if(mySymbol=="EURUSD") return(11);
	if(mySymbol=="GBPCHF") return(12);
	if(mySymbol=="GBPJPY") return(13);
	if(mySymbol=="GBPUSD") return(14);
	if(mySymbol=="NZDUSD") return(15);
	if(mySymbol=="USDCAD") return(16);
	if(mySymbol=="USDCHF") return(17);
	if(mySymbol=="USDJPY") return(18);
   
   
   Comment("unexpected Symbol");
	return(19);
}


